/*******************************************************************************
 * $Id: CompactGappedAlignment.cpp,v 1.27 2004/03/01 02:40:08 darling Exp $
 * This file is copyright 2002-2004 Aaron Darling.  All rights reserved.
 * Please see the file called COPYING for licensing, copying, and modification
 * rights.  Redistribution of this file, in whole or in part is prohibited
 * without express permission.
 ******************************************************************************/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "libMems/CompactGappedAlignment.h"
#include <sstream>
#include "libGenome/gnFilter.h"

#include <fstream>

using namespace std;
using namespace genome;
namespace mems {

CompactGappedAlignment::CompactGappedAlignment( uint seq_count, gnSeqI align_length ) : 
AbstractGappedAlignment< SparseAbstractMatch<> >( seq_count, align_length )
{}


void CompactGappedAlignment::SetAlignment( const std::vector< std::string >& seq_align ){
	if( seq_align.size() == 0 )
	{
		SetAlignmentLength(0);
		return;
	}
	SetAlignmentLength(seq_align[0].size());
	align_matrix = std::vector< bitset_t >( seq_align.size(), bitset_t( seq_align[0].size(), false ) );
	bcount = std::vector< std::vector<size_t> >( seq_align.size() );
	for( size_t seqI = 0; seqI < seq_align.size(); seqI++ )
	{
		bool nonzero = false;
		for( size_t charI = 0; charI < seq_align[seqI].size(); charI++ )
			if( seq_align[seqI][charI] != '-' )
			{
				align_matrix[seqI].set(charI);
				nonzero = true;
			}
	}
	create_bitcount();
}

}
